-----------------------------[-----------------------------[ Requirements ]-----------------------------]-----------------------------
require 'simple-slider'
-----------------------------[-----------------------------[ Localising / Variables ]-----------------------------]-----------------------------
local Selector, Selector2, Max_options
local menu_font
local A1, A2, A3, A4, A5, A6
local Menustate
local WidthS, HeightS
local Snake
local screen_width, screen_height

screen_width, screen_height = love.window.getDesktopDimensions()
-----------------------------[-----------------------------[ Outside Variables ]-----------------------------]-----------------------------
local Menu = {Active = 1, Select = "Exit", gridXCount = 40, gridYCount = 40}
-----------------------------[-----------------------------[ Main ]-----------------------------]-----------------------------

function Menu.load()
    love.graphics.setColor(255,255,255)

    Snake = {x = 100,
             y = 500,
             w = 20,
             h = 20,
             direction = "right",
             speed = 200,
             cellSize = 15,
             Alive = true,
             R = 0,
             G = 255,
             B = 0,
             Segments = {
             {x = 3, y = 1},
             {x = 2, y = 1},
             {x = 1, y = 1}
             }
             }

    love.mouse.setVisible(false)
    Menustate = "Menu"
    menu_font = love.graphics.newFont('PixelFJVerdana12pt_0.ttf', 20)
    love.graphics.setFont(menu_font)

    Selector = 1
    Selector2 = 1

    A1 = 40
    A2 = 20
    A3 = 20
    A4 = 20
    A5 = 40
    A6 = 20


    WidthS = newSlider(
            170,
            80,
            300,
            Menu.gridXCount * Snake.cellSize,
            0,
            screen_width,
            function (v)
                Menu.gridXCount = math.floor(v) / Snake.cellSize
                math.floor(Menu.gridXCount)
            end
            )

    HeightS = newSlider(
            170,
            160,
            300,
            Menu.gridYCount * Snake.cellSize,
            0,
            screen_height,
            function (v)
                Menu.gridYCount = math.floor(v) / Snake.cellSize
                math.floor(Menu.gridYCount)
            end
            )
end

function Menu.update()
    WidthS:update()
    HeightS:update()
end

function Menu.keypressed(key)
    if Menustate ~= "settings" then

    Max_options = 3

    if key == 'down' or key == 's' then
        Selector = Selector + 1
        if Selector > Max_options then Selector = 1 end

    elseif key == 'up' or key == 'w' then
        Selector = Selector - 1
        if Selector < 1 then Selector = Max_options end

    elseif key == 'return' then
        if Menustate == "Menu" then

        if Selector == 1 then
            Menu.Active = 0
        end

        if Selector == 2 then
            Menustate = "settings"
            love.mouse.setVisible(true)
            love.graphics.clear()
        end

        if Selector == 3 then
            love.event.quit()
        end

        end
    end

    if Selector == 1 then
        A1 = 40
    else
        A1 = 20
    end

    if Selector == 2 then
        A2 = 40
    else
        A2 = 20
    end

    if Selector == 3 then
        A3 = 40
    else
        A3 = 20
    end

    else

    Max_options = 2

    if key == 'down' or key == 's' then
        Selector2 = Selector2 + 1
        if Selector2 > Max_options then Selector2 = 1 end

    elseif key == 'up' or key == 'w' then
        Selector2 = Selector2 - 1
        if Selector2 < 1 then Selector2 = Max_options end

    elseif key == 'return' then
        if Selector2 == 1 then
            love.window.setMode(Menu.gridXCount * 15, Menu.gridYCount * 15)
            print(love.graphics.getHeight(), love.graphics.getWidth())
            Menu.load()
        end

        if Selector2 == 2 then
            Menu.load()
        end
    end

    if Selector2 == 1 then
        A5 = 40
    else
        A5 = 20
    end

    if Selector2 == 2 then
        A6 = 40
    else
        A6 = 20
    end

    end

end

function Menu.draw()
    if Menu.Active == 1 then
        if Menustate == "settings" then
            love.graphics.setBackgroundColor(0, 0, 0)

            love.graphics.setLineWidth(4)
            love.graphics.setColor(254, 67, 101)

            -- draw slider, set color and line style before calling
            WidthS:draw()
            HeightS:draw()

            love.graphics.setColor(255, 0, 0)
            love.graphics.rectangle("line", 400, 55, screen_width/ Snake.cellSize + 10, screen_height/ Snake.cellSize + 10)
            love.graphics.setColor(255, 255, 255)
            love.graphics.rectangle("line", 405, 60, Menu.gridXCount, Menu.gridYCount)

            if Menu.gridXCount == screen_width/ Snake.cellSize and
                Menu.gridYCount == screen_height/ Snake.cellSize  or
                Menu.gridYCount == 0 or
                Menu.gridXCount == 0 then

                love.graphics.printf("Fullscreen", 375, 10, 400)
            else
                love.graphics.printf(tostring(math.floor(Menu.gridXCount * Snake.cellSize) ..'X'.. math.floor(Menu.gridYCount * Snake.cellSize)) , 375, 10, 400)
            end

            love.graphics.printf("Screen Width", 10, 10, 400)
            love.graphics.printf("Screen Height", 10, 100, 400)

            love.graphics.printf("Apply and Exit", A5, love.graphics.getHeight()-110, 400)
            love.graphics.printf("Cancel", A6, love.graphics.getHeight()-50, 400)

        elseif Menustate == "info" then
            love.graphics.printf("Made by Loki, Runs on a Potato", 20, 10, 200)
            love.graphics.printf("Back", 20, love.graphics.getHeight()-100, 200)
        else
            love.graphics.printf("Begin", A1, 10, 200)
            love.graphics.printf("Settings", A2, 110, 200)
            love.graphics.printf("Exit", A3, 210, 200)
            --love.graphics.line(800,900,200,1)
        end
    else
        love.graphics.clear()
    end
end

return Menu, Snake, gridYCount, gridXCount





